#!/usr/bin/php -q
<?php
/*
 +-------------------------------------------------------------------------+
 | Copyright (C) 2010 GNU GPLv2                                            |
 |                                                                         |
 | This program is free software; you can redistribute it and/or           |
 | modify it under the terms of the GNU General Public License             |
 | as published by the Free Software Foundation; either version 2          |
 | of the License, or (at your option) any later version.                  |
 |                                                                         |
 | This program is distributed in the hope that it will be useful,         |
 | but WITHOUT ANY WARRANTY; without even the implied warranty of          |
 | MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the           |
 | GNU General Public License for more details.                            |
 +-------------------------------------------------------------------------+
*/

/* do NOT run this script through a web browser */
if (!isset($_SERVER["argv"][0])) {
	die("<br><strong>This script is only meant to run at the command line.</strong>");
}

$no_http_headers = true;

/* ------------------------------------------------------------------------
   Main
   ------------------------------------------------------------------------ */
  $idx= array();
  initfileidx($idx);
  initdefault($default);
  $thepath= dirname(__FILE__);
  $continue= readparameters($thepath,$thefile,$help,$hosttemplate,$showalldevinfo,$separator);
  $cactipath= $thepath;
  if ($help) usage();
  if (!is_file($cactipath."/include/config.php")) {
    $err= "ERR_CACTIPATH";
    showerror($err,$deviceparams,$idx);
    return 1;
  } else {
    include($cactipath."/include/global.php");
    include_once($config["base_path"]."/lib/database.php");
    include_once($config["base_path"]."/lib/utility.php");
    include_once($config["base_path"]."/lib/api_data_source.php");
    include_once($config["base_path"]."/lib/api_graph.php");
    include_once($config["base_path"]."/lib/snmp.php");
    include_once($config["base_path"]."/lib/data_query.php");
    include_once($config["base_path"]."/lib/api_device.php");

    if ($showalldevinfo>0) {
       // option --all-device-infos
       show_devices_allparam($separator,($showalldevinfo>1));
       return 1;
    }
    if ($hosttemplate) {
       // option --host-templates
       print_array(get_host_templates(),"Cacti templates",true,false); print "\n";
    }
    if (!is_file($thefile)) {
       // option --file or --f
       print "ERROR: wrong file!\n";
       $continue = false;
       return 1;
    }
  }
  if ($continue) {
        $handle = fopen($thefile, "r");
        if ($handle) {
           while (!feof($handle)) {
             $buff = fgets($handle);
             // we search the values to insert/change and place them in parameters
             unset($deviceparams);
             $deviceparams = array();
             readlinecolumns($buff,$separator,$deviceparams);
             // when device with parameters do following
             if (sizeof($deviceparams)>0) {
//print_array($deviceparams,"PARAMETERS:",false,true);
//print "\n";
               $err= add_modify_device($deviceparams,$idx,$default);
               showerror($err,$deviceparams,$idx);
//print "\n";
             }
           } // end while
        }
        if ($handle) fclose($handle);
  }

return 0;
exit;
/* ------------------------------------------------------------------------
   END Main
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   readline colummns
   read columns of a line separated with a separator (default ,)
        but not " or ' which are string 
   ------------------------------------------------------------------------ */
function readlinecolumns($buffer,$separator,&$parameters)
{
   $parameters= array();
   if ($buffer) {
       $buffer2=trim($buffer);
       $pattern = '/^#/';
       if (!preg_match($pattern, $buffer2)) {
        // search parameters
         $valuetab= preg_split('/'.$separator.'/',$buffer2,-1);
        // reassemble parameters with " or '
        $istring1 = false;
        $istring2 = false;
        $i = 0;
        foreach ($valuetab as $indx => $para) {
          $len_para = strlen($para);
          if ( ($len_para>0) && ( ($para[0]=="\"") || ($para[0]=="'")) ) {
             // begin of a string
             if ($para[0]=="\"") {
                $parameters[$i] = $para;
                if ( ($len_para>1) && ($para[$len_para-1]=="\"") ) {
                   // it is the end of str
                   $istring1 = false;
                   $i++;
                } else {
                   $istring1 = true;
                }
             }
             if ($para[0]=="'") {
                $parameters[$i] = $para;
                if ( ($len_para>1) && ($para[$len_para-1]=="'") ) {
                   // it is the end of str
                   $istring2 = false;
                   $i++;
                } else {
                   $istring2 = true;
                }
             } 
           } else {
             if ($istring1 || $istring2) {
                if ( ($istring1 && ($para[$len_para-1]=="\"")) || ($istring2 && ($para[$len_para-1]=="'")) ) {
                  $parameters[$i] = $parameters[$i].$para;
                  $istring1 = $istring2 = false;
                  $i++;
                } else {
                  // we are still in the string
                  $parameters[$i] = $parameters[$i].$para;
                }
             } else {
               // normal parameter
               $parameters[$i] = $para;
               $i++;
             }
          } 
        } // foreach
       } // for each arguments
       if (sizeof($parameters)>0) {
          // remove first and last ' or "
          foreach ($parameters as $id=>$val) {
             $val2= trim($val);
             $parameters[$id] = $val2;
             $len= strlen($val2);
             if (($len>1) && (($val2[0]=="'")||($val2[0]=='"'))
                  && (($val2[$len-1]=="'")||($val2[$len-1]=='"')) )
                $parameters[$id]=substr($val2,1,$len-2);
          }
       }
   }
}
/* ------------------------------------------------------------------------
   END readline colummns
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   initialise index file
   ------------------------------------------------------------------------ */
function initfileidx(&$idx)
{
  $idx["description"]=0;
  $idx["hostname"]=1;
  $idx["template"]=2;
  $idx["notes"]=3;
  $idx["disabled"]=4;
  $idx["availability_method"]=5;
  $idx["ping_method"]=6;
  $idx["ping_port"]=7;
  $idx["ping_timeout"]=8;
  $idx["ping_retries"]=9;
  $idx["version"]=10;
  $idx["community"]=11;
  $idx["port"]=12;
  $idx["snmp_timeout"]=13;
  $idx["username"]=14;
  $idx["password"]=15;
  $idx["authproto"]=16;
  $idx["privpass"]=17;
  $idx["privproto"]=18;
  $idx["context"]=19;
  $idx["max_oids"]=20;
  $err = 0;
  return $err;
}
/* ------------------------------------------------------------------------
   END initialise index file
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   init default
   ------------------------------------------------------------------------ */
function initdefault(&$def)
{
   $def["snmp_version"]= "1";
   $def["snmpport"]= "161";
   $def["availability_method"]= "1";
   $def["snmp_community"]= "public";
   $def["snmp_timeout"]= "500";
   $def["ping_method"]= "3";
   $def["ping_retries"]= "3";
   $def["ping_timeout"]= "500";
   $def["snmp_auth_protocol"]= "MD5";
   $def["snmp_priv_protocol"]= "[none]";
   $def["max_oids"]= "10";
}

/* ------------------------------------------------------------------------
   END init default
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   showerror
   ------------------------------------------------------------------------ */
function showerror($er,&$parameters,&$idx)
{
        switch ("$er") {
           case "ERR_CACTIPATH":
              print "ERROR: path to cacti is wrong!\n";
              break;
           case "0": // no error
	      print "OK! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." TEMPL:".$parameters[$idx["template"]]."\n";
              break;
           case "ERR_TEMPL":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Unknown template '".$parameters[$idx["template"]]."'\n";
              break;
           case "ERR_SNMPVERSION":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong SNMP version '".$parameters[$idx["version"]]."'\n";
              break;
           case "ERR_DISABLE":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong value for disabled '".$parameters[$idx["disabled"]]."'\n";
              break;
           case "ERR_PORT":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong snmp port '".$parameters[$idx["port"]]."'\n";
              break;
           case "ERR_PINGPORT":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong ping port '".$parameters[$idx["ping_port"]]."'\n";
              break;
           case "ERR_AVAILABLE":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong availability method '".$parameters[$idx["availability_method"]]."'\n";
              break;
           case "ERR_TIMEOUT":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong timeout (snmp or ping) \n";
              break;
           case "ERR_PINGMETHOD":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong ping method '".$parameters[$idx["ping_method"]]."'\n";
              break;
           case "ERR_PINGRETRIES":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong ping retries '".$parameters[$idx["ping_retries"]]."'\n";
              break;
           case "ERR_SNMPAUTH":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong snmp authentification '".$parameters[$idx["authproto"]]."'\n";
              break;
           case "ERR_SNMPPRIVPROTO":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong snmp privproto '".$parameters[$idx["privproto"]]."'\n";
              break;
           case "ERR_MAXOIDS":
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Wrong maxoids value '".$parameters[$idx["maxoids"]]."'\n";
              break;
           default :
	      print "ERROR! description:".$parameters[$idx["description"]]." IP:".$parameters[$idx["hostname"]]
                      ." Unkown Error\n";
              break;
        }
  return 0;
}
/* ------------------------------------------------------------------------
   END showerror
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   searchlowercasearray  
   ------------------------------------------------------------------------ */
function searchlowercasearray($niddle,&$tarray,&$result,$searchkey=false)
{
    // not case sensitive
    $exist = false;$result=-1;
    $comp= mb_strtolower($niddle);
    foreach ($tarray as $key=>$val) {
      if ( ($comp==mb_strtolower($val)) || ($searchkey && ($comp==mb_strtolower($key))) ) {
          $exist=true; $result=$key; break;
      } 
    } 
    return $exist;
}
/* ------------------------------------------------------------------------
   END searchlowercasearray  
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   retrieve template id 
   ------------------------------------------------------------------------ */
function retrieve_templateid($devtemplate)
{
    $templ = $devtemplate;
    // retrieve the template id
    $host_templates = get_host_templates();
    // not case sensitive
    $exist = -1;
    $comp= mb_strtolower($devtemplate);
    foreach ($host_templates as $key=>$val) {
      if ($comp==mb_strtolower($val)) { $exist=1; $templ=$key; break; } 
    } 
    if ($exist<0) {
//   if (!array_key_exists($templ, $host_templates)) {
//      $templ = array_search($templ, $host_templates);
//      if ($templ===false) {
         $templ = "ERR_TEMPL";
//      }
    }
    return $templ;
}
/* ------------------------------------------------------------------------
   retrieve template id 
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   add/modify host
   ------------------------------------------------------------------------ */
function add_modify_device(&$devicechanges,&$indx,&$default)
{
   $returnval = 0;

   $description= $devicechanges[$indx["description"]];
   $hostname= $devicechanges[$indx["hostname"]];
   $snmp_version= $devicechanges[$indx["version"]];
   if ($snmp_version=="2c") $snmp_version="2";
   if ($snmp_version=="")   $snmp_version= $default["snmp_version"];
   if ( ($snmp_version!="1") && ($snmp_version!="2") && ($snmp_version!="3") ) return "ERR_SNMPVERSION";
   $disabled = mb_strtolower($devicechanges[$indx["disabled"]]);
   switch ("$disabled") {
      case "on" : break;
      case "disabled" : 
      case "1": $disabled= "on"; break;
      case "enabled" : 
      case "off": 
      case "''" : 
      case "" : 
      case "0": $disabled= ""; break;
      default : return "ERR_DISABLE";
   }
   $snmp_port= $devicechanges[$indx["port"]];
   if ($snmp_port=="") $snmp_port= $default["snmpport"];
   if ( (!preg_match("/^[0-9]{1,5}$/",$snmp_port)) || ($snmp_port>"65535") ) return "ERR_PORT";
   $availability_method= mb_strtoupper($devicechanges[$indx["availability_method"]]);
   if ($availability_method=="") $availability_method= $default["availability_method"];
   switch ("$availability_method") {
      case "0": 
      case "1": 
      case "2": 
      case "3": 
      case "4": break;
      case "AVAIL_NONE": $availability_method=0; break;
      case "AVAIL_SNMP_AND_PING": $availability_method=1; break;
      case "AVAIL_SNMP": $availability_method=2; break;
      case "AVAIL_PING": $availability_method=3; break;
      case "AVAIL_SNMP_OR_PING": $availability_method=4; break;
      default: return "ERR_AVAILABLE";
   }
   $snmp_community= $devicechanges[$indx["community"]];
   if ($snmp_community=="") $snmp_community= $default["snmp_community"];
   if ($snmp_version=="3") $snmp_community= "";
   $ping_timeout= $devicechanges[$indx["ping_timeout"]];
   if ($ping_timeout=="") $ping_timeout= $default["ping_timeout"];
   if (!preg_match("/^[0-9]{1,5}$/",$ping_timeout) ) return "ERR_TIMEOUT";
   $snmp_timeout= $devicechanges[$indx["snmp_timeout"]];
   if ($snmp_timeout=="") $snmp_timeout= $default["snmp_timeout"];
   if (!preg_match("/^[0-9]{1,5}$/",$snmp_timeout) ) return "ERR_TIMEOUT";

   $h = get_devices($tabdescriptions,$tabhostnames,$tabids,$tabids2);
   $devtemplate= $devicechanges[$indx["template"]];
   $host_template_id= retrieve_templateid($devtemplate);
   if ($host_template_id=="ERR_TEMPL") return $host_template_id;
   $id= 0;
   if (searchlowercasearray($description,$tabids2,$val,false)) {
      $id = $val; 
      print "INFO: This description/device already exists ($description,$hostname) "
             ."--> id=$id (".$description.",".$tabdescriptions[$tabids2[$val]]."). This is a change.\n";
   }
   if (searchlowercasearray($hostname,$tabhostnames,$val,true)) {
//   if ( isset($tabhostnames[$hostname]) ) {
        $id = $tabids[$val]; 
	print "INFO: This host/device already exists ($description,$hostname) "
             ."--> id=$id (".$tabids2[$id].",".$hostname
             ."). This is a change.\n";
   }
   $snmp_username = $devicechanges[$indx["username"]];
   $snmp_password = $devicechanges[$indx["password"]];
   $notes = $devicechanges[$indx["notes"]];
   $ping_method = mb_strtoupper($devicechanges[$indx["ping_method"]]);
   if ($ping_method=="") $ping_method= $default["ping_method"];
   switch ("$ping_method") {
      case "1":
      case "2":
      case "3": break;
      case "PING_ICMP": $ping_method=1; break;
      case "PING_UDP": $ping_method=2; break;
      case "PING_TCP": $ping_method=3; break;
      default: return "ERR_PINGMETHOD";
   }
   $ping_port= $devicechanges[$indx["ping_port"]];
   if ( ($ping_port!="")
      && ((!preg_match("/^[0-9]{1,5}$/",$ping_port)) || ($ping_port>"65535")) ) return "ERR_PINGPORT";
   $ping_port= intval($ping_port);
   $ping_retries= $devicechanges[$indx["ping_retries"]];
   if ($ping_retries=="") $ping_retries= $default["ping_retries"];
   if ( (!preg_match("/^[0-9]{1,3}$/",$ping_retries)) || ($ping_retries>"100") ) return "ERR_PINGRETRIES";
   $ping_retries= intval($ping_retries);
   if ($snmp_version=="3") {
      $snmp_auth_protocol = mb_strtoupper($devicechanges[$indx["authproto"]]);
      if ($snmp_auth_protocol=="") $snmp_auth_protocol= $default["snmp_auth_protocol"];
      switch ("$snmp_auth_protocol") {
         case "MD5": break;
         case "SHA": break;
         default: return "ERR_SNMPAUTH";
      }
      $snmp_priv_passphrase= $devicechanges[$indx["privpass"]];
      $snmp_priv_protocol = mb_strtoupper($devicechanges[$indx["privproto"]]);
      if ($snmp_priv_protocol=="") $snmp_priv_protocol= $default["snmp_priv_protocol"];
      switch ("$snmp_priv_protocol") {
         case "NONE": $snmp_priv_protocol="[none]"; break;
         case "[NONE]": $snmp_priv_protocol="[none]"; break;
         case "DES": break;
         case "AES": $snmp_priv_protocol="AES128"; break;
         case "AES128": break;
         default: return "ERR_SNMPPRIVPROTO";
      }
   } else {
      $snmp_auth_protocol = '';
      $snmp_priv_passphrase= '';
      $snmp_priv_protocol= '';
   }
   $snmp_context= $devicechanges[$indx["context"]];
   $max_oids= $devicechanges[$indx["max_oids"]];
   if ($max_oids=="") $max_oids= $default["max_oids"];
   if ( (!preg_match("/^[0-9]{1,2}$/",$max_oids)) || ($max_oids>"60") ) return "ERR_MAXOIDS";

//print "id=$id, hostname=$hostname, description=$description, host_template_id=$host_template_id, snmp_community=$snmp_community snmpversion=$snmpversion, snmp_username=$snmp_username, snmp_password=$snmp_password, snmp_port=$snmp_port, snmp_timeout=$snmp_timeout, disabled=$disabled, availability_method=$availability_method, ping_method=$ping_method, ping_port=$ping_port, ping_timeout=$ping_timeout, ping_retries=$ping_retries, notes=$notes, snmp_auth_protocol=$snmp_auth_protocol, snmp_priv_passphrase=$snmp_priv_passphrase, snmp_priv_protocol=$snmp_priv_protocol, snmp_context=$snmp_context, max_oids=$max_oids*\n";

   // we use cacti API
   $hostid= api_device_save($id, $host_template_id, $description, $hostname, $snmp_community
        , $snmp_version, $snmp_username, $snmp_password, $snmp_port, $snmp_timeout, $disabled
        ,$availability_method, $ping_method, $ping_port, $ping_timeout, $ping_retries
        ,$notes, $snmp_auth_protocol, $snmp_priv_passphrase, $snmp_priv_protocol, $snmp_context, $max_oids) ;
   if (is_error_message()) {
	print "Failed to add $hostname, $description \n";
        $returnval = 1;
   } else {
	print "INFO: Adding/modifying successful for id=$hostid $hostname, $description !\n";
        $returnval = 0;
   }
   return $returnval;
exit;
}
/* ------------------------------------------------------------------------
   END add/modify host
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   Retrieve host templates from Cacti's DB
   ------------------------------------------------------------------------ */
function get_host_templates()
{
	$tmparray = db_fetch_assoc("select id, name from host_template order by id");
	foreach ($tmparray as $template)
		$host_templates[$template["id"]] = $template["name"];
	return $host_templates;
}
/* ------------------------------------------------------------------------
   Retrieve host templates from Cacti's DB
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   Display array
   ------------------------------------------------------------------------ */
function print_array(&$table,$title,$indx,$condense=false)
{
	print "$title";
        if (!$condense) print "\n";
	foreach ($table as $id => $name) {
	    if ($indx) print "$id => ";
            print "$name";
            if (! $condense) print "\n";
            else print ",";
	}
}
/* ------------------------------------------------------------------------
   END Display array
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   get all devices from Cacti's DB
   ------------------------------------------------------------------------ */
function get_devices(&$tabdescr,&$tabdev,&$tabid,&$tabid2)
{
    $tabdescr = array();
    $tabdev = array();
    $tabid = array();
    $tabid2= array();
    $tmparray = db_fetch_assoc("select id,description,hostname from host order by description");
    foreach ($tmparray as $tmp) {
	$tabdescr[$tmp["description"]] = $tmp["hostname"];
	$tabdev[$tmp["hostname"]] = $tmp["description"];
	$tabid[$tmp["hostname"]] = $tmp["id"];
	$tabid2[$tmp["id"]] = $tmp["description"];
    }
    return true;
}
/* ------------------------------------------------------------------------
   END get all devices from Cacti's DB
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   show with all parameters all devices from Cacti's DB
   ------------------------------------------------------------------------ */
function show_devices_allparam($separ,$withid=false)
{
    $ttempl = db_fetch_assoc("select * from host_template ");
    $atempl = array();
    foreach ($ttempl as $temp) {
      $atempl[$temp["id"]] = $temp["name"];
    }
    $tmparray = db_fetch_assoc("select * from host order by description");
    foreach ($tmparray as $tmp) {
      print "#";
      if ($withid) print "id".$separ."";
      print "description".$separ."hostname".$separ."template".$separ."notes".$separ
           ."disabled".$separ."availability_method".$separ."ping_method".$separ."ping_port".$separ
           ."ping_timeout".$separ."ping_retries".$separ."version".$separ."community".$separ
           ."port".$separ."snmp_timeout".$separ."username".$separ."password".$separ
           ."authproto".$separ."privpass".$separ."privproto".$separ."context".$separ."max_oids\n";
      if ($withid) print "\"".$tmp["id"]."\"".$separ;
      print "\"".$tmp["description"]."\"".$separ;
      print "\"".$tmp["hostname"]."\"".$separ;
      $ntempl= (isset($atempl[$tmp["host_template_id"]])) ? $atempl[$tmp["host_template_id"]]:0;
      print "\"".$ntempl."\"".$separ;
      print "\"".$tmp["notes"]."\"".$separ;
      print "\"".(($tmp["disabled"]!='')?'disabled':'enabled')."\"".$separ;
      switch ($tmp["availability_method"]) {
         case 0: $avail="AVAIL_NONE"; break;
         case 1: $avail="AVAIL_SNMP_AND_PING"; break;
         case 2: $avail="AVAIL_SNMP"; break;
         case 3: $avail="AVAIL_PING"; break;
         case 4: $avail="AVAIL_SNMP_OR_PING"; break;
         default: $avail="";
      }
      print "\"".$avail."\"".$separ;
      switch ($tmp["ping_method"]) {
         case 1: $ping_method="PING_ICMP"; break;
         case 2: $ping_method="PING_UDP"; break;
         case 3: $ping_method="PING_TCP"; break;
         default: return "ERR_PINGMETHOD";
      }
      print "\"".$ping_method."\"".$separ;
      print "\"".$tmp["ping_port"]."\"".$separ;
      print "\"".$tmp["ping_timeout"]."\"".$separ;
      print "\"".$tmp["ping_retries"]."\"".$separ;
      print "\"".$tmp["snmp_version"]."\"".$separ;
      print "\"".$tmp["snmp_community"]."\"".$separ;
      print "\"".$tmp["snmp_port"]."\"".$separ;
      print "\"".$tmp["snmp_timeout"]."\"".$separ;
      print "\"".$tmp["snmp_username"]."\"".$separ;
      print "\"".$tmp["snmp_password"]."\"".$separ;
      print "\"".$tmp["snmp_auth_protocol"]."\"".$separ;
      print "\"".$tmp["snmp_priv_passphrase"]."\"".$separ;
      print "\"".$tmp["snmp_priv_protocol"]."\"".$separ;
      print "\"".$tmp["snmp_context"]."\"".$separ;
      print "\"".$tmp["max_oids"]."\"" ;
      print "\n";
    }
    return true;
}
/* ------------------------------------------------------------------------
   END Retrieve all known devices from Cacti's DB
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   usage
   ------------------------------------------------------------------------ */
function usage()
{
  $filename= $_SERVER["argv"][0];
  echo "Usage:
$filename [--host-templates] [--all-device-infos] [--separator='character'] [--help] [--cacti=cactipath] [--f=filename] 
	--all-device-infos          show all devices with all information (in format 'hosts file FORMAT')
	--all-device-infos-with-id  show all devices with all information with id
        --separator                 (default ',') for example ',' or ';'
	--host-templates	    returns the valid host templates
        --cacti=cactipath           give the cacti path. If empty you must start from cacti folder
        --f=filename                to create several cacti devices (see hosts file FORMAT)
        --file=filename             to create several cacti devices (see hosts file FORMAT)

'hosts file FORMAT':
   description,hostname,template,notes,disabled,availability_method,ping_method,ping_port,ping_timeout,ping_retries,version,community,port,snmp_timeout,username,password,authproto,privpass,privproto,context,max_oids

   WHERE:
   description  device's description (hostname if hostname field is a ip) (this is the cacti description field)
   hostname     hostname or ip of the device (this will be the cacti hostname parameter)
   template     name or number of template (list of templates could be see with --host-templates), (default=0)
   notes        '', General information about this host.  Must be enclosed using double quotes.
   disabled     default=0, 1 (or disabled or off),  0 (or enabled or '' or 'off')
   availability_method  default=1, (0,1,2,3,4) or AVAIL_NONE, AVAIL_SNMP_AND_PING, AVAIL_SNMP, AVAIL_PING, AVAIL_SNMP_OR_PING
   ping_method  default=3, (1,2,3) or PING_ICMP, PING_UDP, PING_TCP
   ping_port    '', 1-65534
   ping_timeout 500
   ping_retries 2, the number of time to attempt to communicate with a host
   version      default=1, 1,2 or 2c ,3, snmp version
   community    '', snmp community string for snmpv1 and snmpv2.  Leave blank for no community
   port         161
   snmp_timeout 500
   username     '', snmp username for snmpv3
   password     '', snmp password for snmpv3
   authproto    '', MD5 or SHA, snmp authentication protocol for snmpv3
   privpass     '', [none], DES, AES, snmp privacy passphrase for snmpv3
   privproto    '', snmp privacy protocol for snmpv3
   context      '', snmp context for snmpv3
   max_oids     default 10, between 1 and 60, the number of OID's for a SNMP Get request
\n";
}
/* ------------------------------------------------------------------------
   END usage
   ------------------------------------------------------------------------ */

/* ------------------------------------------------------------------------
   read parameters
   ------------------------------------------------------------------------ */
function readparameters(&$cactip,&$filex,&$help,&$hosttemplate,&$showalldevinfo,&$separator)
{
  $separator =",";
  $cactip = ""; $filex=""; $filey ="";
  $help=false;
  $hosttemplate=false;
  $showalldevinfo= 0;
  $ok=false;
  if ($_SERVER["argc"]==1) usage();
  for ($i = 1; ($i < $_SERVER["argc"]); $i++) {
//print "ANALYSE: FILE-ARGV[$i]=".$_SERVER["argv"][$i]."\n"; 
    $value= preg_split('/=/',$_SERVER["argv"][$i],-1,PREG_SPLIT_NO_EMPTY);
//print "VALUES=".print_r($value,1)."\n";
    switch ($value[0]) {
	case "-h":
	case "--h":
	case "--help":
             $help=true;
             $ok= false; // force in case of several arguments
	     break;
	case "--host-templates":
             $hosttemplate=true;
             $ok= false; // force in case of several arguments
	     break;
	case "--separator":
             $separator=isset($value[1]) ? $value[1]: ",";
	     break;
	case "--all-device-infos":
             $showalldevinfo=1;
             $ok= false; // force in case of several arguments
	     break;
	case "--all-device-infos-with-id":
             $showalldevinfo=2;
             $ok= false; // force in case of several arguments
	     break;
	case "--cacti":
             $cactip= isset($value[1]) ? $value[1]: $cactip;
             $ok= true;
	     break;
        case "-f":
             $ok= false;
             if (isset($_SERVER["argv"][$i+1])) {
                $filex= $_SERVER["argv"][$i+1];
                if ("$filex"!="") {
                    $ok= true;
                    $i++;
                }
             }
             break;
	case "--f":
	case "--file":
             $filex= isset($value[1]) ? $value[1]: $filex;
             $ok= true;
	     break;
	default:
             // at least the filename
             $ok= false;
             break;
    }
  }
  return $ok;
}
/* ------------------------------------------------------------------------
   END read parameters
   ------------------------------------------------------------------------ */

?>
